/*
 * Presenter Club - Make Great Presentations, Faster
 * Copyright (C) 2016 Sam Parkinson <sam@sam.today>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

.SlideEditor__row {
    padding: 0;
    height: 80vh;
    display: flex;
}

.SlideEditor__background,
.SlideEditor__SlideInner {
    display: flex;
    flex-grow: 1;
    height: 100%;
}

.SlideEditor {
    padding: 20px;
    width: 100%;
    height: 80vh;

    .slide {
        border: 2px dashed _palette(border);
    }

    transition: box-shadow _duration(transition) ease-in-out,
                transform (_duration(transition) * 10) ease-in-out;
}

.SlideEditor__row {
    overflow: hidden;
}
.SpeechViewTransition-enter {
    &.SlideEditor__row {
        height: 0;
    }
}
.SpeechViewTransition-enter.SpeechViewTransition-enter-active {
    &.SlideEditor__row {
        transition: height _duration(transition) ease-in-out;
        height: 80vh;
    }
}
.SpeechViewTransition-leave {
    &.SlideEditor__row {
        height: 80vh;
    }
    &.SpeechRow {
        display: none;
    }
}
.SpeechViewTransition-leave.SpeechViewTransition-leave-active {
    &.SlideEditor__row {
        transition: height _duration(transition) ease-in-out;
        height: 0;
    }
}

.SlideEditor--overlayed-toolbar {
    box-shadow: inset 0 0 _size(element-margin) _palette(bg);
}

.SlideEditor__toolbar {
    height: 2em;
}
.SlideEditor__toolbar--overlay {
    position: relative;
    margin-top: -2em;
}
.SlideEditor__toolbar--main {
    transition: transform _duration(transition) ease-in-out;
}
.SlideEditor--overlayed-toolbar .SlideEditor__toolbar--main {
    transform: rotateX(90deg);
    pointer-events: none;
}
@keyframes SlideEditor__toolbar--overlay--enter {
  0%   { transform: rotateX(-90deg); }
  100% { transform: rotateX(0); }
}
.SlideEditor__toolbar--overlay {
    animation: _duration(transition) ease-in-out
               SlideEditor__toolbar--overlay--enter;
}

.SlideEditorSidebar {
    width: 420px;

    display: flex;
    overflow-y: scroll;
    flex-direction: column;

    input.search {
        width: 380px;
        margin-left: 15px;
    }

    label {
        margin-left: 0.5em;
    }
}
.SlideEditorSidebar__header {
    background: _palette(header-bg);
    color: _palette(header-fg);
    border-bottom: 2px solid transparentize(_palette(accent), 0.5);
    margin-bottom: 1em;

    display: flex;
    flex-direction: column;
    flex-shrink: 0;
    height: 3em;
}
.SlideEditorSidebar__header--secondary {
    background: _palette(accent);
    border-bottom: 2px solid transparentize(_palette(header-bg), 0.5);
}

.SlideEditorSidebar__title {
    padding-left: 0.5em;
    padding-right: 0.5em;
    margin-bottom: 0;
    flex-grow: 1;
}
.SlideEditorSidebar__title--only {
    margin-top: 0.75em;
}
.SlideEditorSidebar__go_back {
    margin-bottom: 1em;
    padding-left: 0.5em;
    font-size: 0.8em;
    &:hover {
        color: darken(_palette(header-fg), 20%);
    }
}
.SlideEditorSidebar__go_back__title {
    font-style: italic;
    padding-left: 0.2em;
}

.SidebarSection__header {
    background: opacify(_palette(border-bg), 0.1);
    border-bottom: 2px solid _palette(border);
    border-top:    2px solid _palette(border);
    height: 3em;

    display: flex;
    flex-shrink: 0;
    margin-bottom: 0.5em;

    input {
        background: none;
        border: none;
    }

    &:after {
        @extend .fontello;
        margin: 0.5em;
        content: '';  /* down arrow */
        transition: transform _duration(transition) ease-in-out;
        transform: rotate(0);
    }
}
.SidebarSection--expanded__header {
    &:after {
        transform: rotate(180deg);
    }
}
.SidebarSection--expanded__header--hide-arrow,
.SidebarSection__header--hide-arrow {
    &:after {
        transform: scale(0);
    }
}

.SidebarSection__title {
    flex-grow: 1;
    margin: 0.5em;
    @include unselectable();
}

.SidebarSection__children {
    flex-shrink: 0;
    transition: max-height _duration(transition) ease-in-out,
                transform _duration(transition) ease-in-out;
    padding-bottom: 0.5em;

    max-height: 0;
    overflow-y: hidden;
    transform-origin: top center;
    transform: scaleY(0);
}
.SidebarSection--expanded__children {
    max-height: initial;
    transform: scaleY(1);
}

.Sidebar__link {
    font-size: 0.8em;
    color: _palette(accent);

    &:hover {
        color: lighten(_palette(accent), 20%);
    }
}
.Sidebar__center--text {
    font-size: 0.8em;
    .Sidebar__link {
        font-size: 1em;
    }
}

.Sidebar__center {
    display: flex;
    justify-content: center;
    text-align: center;
}

.Sidebar__PoweredBy {
    margin-bottom: 0.5em;
}

.UploadSizeLabel {
    display: inline;
    margin-right: 0.5em;
}
